## qtcreator 4.14.1

=== src/CMakeLists.txt ===
add_library(app_version INTERFACE)
target_include_directories(app_version
  INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
  INTERFACE $<INSTALL_INTERFACE:include/src>)
install(TARGETS app_version EXPORT QtCreator)

add_subdirectory(libs)
add_subdirectory(share)
add_subdirectory(shared)
add_subdirectory(app)
add_subdirectory(plugins)
add_subdirectory(tools)

install(
  FILES
    ${PROJECT_SOURCE_DIR}/HACKING
    ${PROJECT_SOURCE_DIR}/LICENSE.GPL3-EXCEPT
    ${PROJECT_SOURCE_DIR}/README.md
  DESTINATION ./
  COMPONENT Devel EXCLUDE_FROM_ALL
)

install(
  DIRECTORY
    ${PROJECT_SOURCE_DIR}/scripts
  DESTINATION ./
  COMPONENT Devel EXCLUDE_FROM_ALL
  USE_SOURCE_PERMISSIONS
)

install(EXPORT QtCreator
  DESTINATION "lib/cmake/QtCreator"
  COMPONENT Devel EXCLUDE_FROM_ALL
  NAMESPACE QtCreator::
  FILE QtCreatorTargets.cmake
)

file(WRITE ${CMAKE_BINARY_DIR}/cmake/QtCreatorConfig.cmake "
\# add module path for special FindQt5.cmake that considers Qt6 too
list(APPEND CMAKE_MODULE_PATH \${CMAKE_CURRENT_LIST_DIR})

\# force plugins to same path naming conventions as Qt Creator
\# otherwise plugins will not be found
if(UNIX AND NOT APPLE)
  include(GNUInstallDirs)
  set(CMAKE_INSTALL_BINDIR ${CMAKE_INSTALL_BINDIR})
  set(CMAKE_INSTALL_LIBDIR ${CMAKE_INSTALL_LIBDIR})
  set(CMAKE_INSTALL_LIBEXECDIR ${CMAKE_INSTALL_LIBEXECDIR})
  set(CMAKE_INSTALL_DATAROOTDIR ${CMAKE_INSTALL_DATAROOTDIR})
endif()

include(CMakeFindDependencyMacro)
find_dependency(Qt5 ${IDE_QT_VERSION_MIN}
  COMPONENTS Concurrent Core Gui Widgets Core5Compat Network PrintSupport Qml Quick QuickWidgets Sql REQUIRED
)

if (NOT IDE_VERSION)
  include(\${CMAKE_CURRENT_LIST_DIR}/QtCreatorIDEBranding.cmake)
endif()

if (NOT DEFINED add_qtc_plugin)
  include(\${CMAKE_CURRENT_LIST_DIR}/QtCreatorAPI.cmake)
endif()

if (NOT DEFINED add_translation_targets)
  include(\${CMAKE_CURRENT_LIST_DIR}/QtCreatorTranslations.cmake)
endif()

if (NOT DEFINED add_qtc_documentation)
  include(\${CMAKE_CURRENT_LIST_DIR}/QtCreatorDocumentation.cmake)
endif()

if (NOT TARGET QtCreator::Core)
  include(\${CMAKE_CURRENT_LIST_DIR}/QtCreatorTargets.cmake)
endif()
")

# Local build export
export(EXPORT QtCreator
  NAMESPACE QtCreator::
  FILE ${CMAKE_BINARY_DIR}/cmake/QtCreatorTargets.cmake)

file(COPY
  ${IDE_BRANDING_FILE}
  ${PROJECT_SOURCE_DIR}/cmake/QtCreatorTranslations.cmake
  ${PROJECT_SOURCE_DIR}/cmake/QtCreatorDocumentation.cmake
  ${PROJECT_SOURCE_DIR}/cmake/QtCreatorAPI.cmake
  ${PROJECT_SOURCE_DIR}/cmake/QtCreatorAPIInternal.cmake
  ${PROJECT_SOURCE_DIR}/cmake/FindQt5.cmake
  ${PROJECT_SOURCE_DIR}/cmake/Config.cmake.in
  ${PROJECT_SOURCE_DIR}/cmake/QtcSeparateDebugInfo.cmake
  ${PROJECT_SOURCE_DIR}/cmake/QtcSeparateDebugInfo.Info.plist.in
  DESTINATION ${CMAKE_BINARY_DIR}/cmake
)

# Devel package install
install(
  FILES
    ${IDE_BRANDING_FILE}
    ${PROJECT_SOURCE_DIR}/cmake/QtCreatorTranslations.cmake
    ${PROJECT_SOURCE_DIR}/cmake/QtCreatorDocumentation.cmake
    ${PROJECT_SOURCE_DIR}/cmake/QtCreatorAPI.cmake
    ${PROJECT_SOURCE_DIR}/cmake/QtCreatorAPIInternal.cmake
    ${PROJECT_SOURCE_DIR}/cmake/FindQt5.cmake
    ${PROJECT_SOURCE_DIR}/cmake/Config.cmake.in
    ${PROJECT_SOURCE_DIR}/cmake/QtcSeparateDebugInfo.cmake
    ${PROJECT_SOURCE_DIR}/cmake/QtcSeparateDebugInfo.Info.plist.in
    ${CMAKE_BINARY_DIR}/cmake/QtCreatorConfig.cmake
  DESTINATION lib/cmake/QtCreator
  COMPONENT Devel EXCLUDE_FROM_ALL
)

=== src/libs/CMakeLists.txt ===
add_subdirectory(3rdparty)

add_subdirectory(advanceddockingsystem)
add_subdirectory(aggregation)
add_subdirectory(extensionsystem)
add_subdirectory(utils)
add_subdirectory(languageutils)
add_subdirectory(cplusplus)
add_subdirectory(modelinglib)
add_subdirectory(qmljs)
add_subdirectory(qmldebug)
add_subdirectory(qmleditorwidgets)
add_subdirectory(glsl)
add_subdirectory(languageserverprotocol)
add_subdirectory(ssh)
add_subdirectory(sqlite)
add_subdirectory(clangsupport)
add_subdirectory(tracing)

add_subdirectory(qtcreatorcdbext)

=== src/shared/CMakeLists.txt ===
add_subdirectory(designerintegrationv2)
add_subdirectory(proparser)
add_subdirectory(qtsingleapplication)
add_subdirectory(qtlockedfile)
add_subdirectory(help)
add_subdirectory(registryaccess)

if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/qbs/CMakeLists.txt)
  set(BUILD_QBS_DEFAULT YES)
else()
  set(BUILD_QBS_DEFAULT FALSE)
endif()

option(BUILD_QBS "Build Qbs together with Qt Creator" ${BUILD_QBS_DEFAULT})

if (BUILD_QBS)
  find_package(Qt5 COMPONENTS Script QUIET)
  if (TARGET Qt5::Script)
    set(ENABLE_BUILD_QBS YES)
  endif()
else()
  set(ENABLE_BUILD_QBS NO)
endif()

add_feature_info("Build Qbs" ENABLE_BUILD_QBS "with CONDITION TARGET Qt5::Script")
if (ENABLE_BUILD_QBS)
  file(RELATIVE_PATH _REL_PATH_TO_QTC "${CMAKE_BINARY_DIR}" "${PROJECT_BINARY_DIR}")
  set(QBS_OUTPUT_PREFIX "${_REL_PATH_TO_QTC}/" CACHE STRING "" FORCE)
  set(QBS_APP_INSTALL_DIR "${IDE_BIN_PATH}" CACHE STRING "" FORCE)
  set(QBS_LIB_INSTALL_DIR "${IDE_LIBRARY_PATH}" CACHE STRING "" FORCE)
  set(QBS_DLL_INSTALL_DIR "${IDE_BIN_PATH}" CACHE STRING "" FORCE)
  set(QBS_LIBEXEC_INSTALL_DIR "${IDE_LIBEXEC_PATH}" CACHE STRING "" FORCE)
  set(QBS_PLUGINS_INSTALL_BASE "${IDE_PLUGIN_PATH}" CACHE STRING "" FORCE)
  set(QBS_RESOURCES_INSTALL_BASE "${IDE_DATA_PATH}/qbs" CACHE STRING "" FORCE)
  set(QBS_DOC_INSTALL_DIR "${IDE_DOC_PATH}" CACHE STRING "" FORCE)
  set(QBS_HEADERS_INSTALL_DIR "${IDE_DATA_PATH}/qbs/include/qbs" CACHE STRING "" FORCE)

  set(INSTALL_PUBLIC_HEADERS OFF CACHE BOOL "")
  set(WITH_TESTS OFF)
  set(WITH_PROJECT_FILE_UPDATES ON)
  set(QBS_INSTALL_QCH_DOCS ${WITH_DOCS} CACHE BOOL "")
  add_subdirectory(qbs)
endif()

=== share/qtcreator/translations/CMakeLists.txt ===
set(languages cs da de fr hr ja pl ru sl uk zh_CN zh_TW)
set(bad_languages hu) # Fix these before including them in languages!

find_package(PythonInterp)

set(json_wizards_h "")
set(custom_wizards_h "")
set(externaltools_h "")
set(snippets_h "")

if (NOT PYTHONINTERP_FOUND OR NOT PYTHON_VERSION_STRING VERSION_GREATER_EQUAL "3.0.0")
  message(WARNING "No python3 interpreter found, skipping extraction of data from XML and JSON files.\n *** Please pass -DPYTHON_EXECUTABLE=/path/to/python3 to cmake.")
else()
  set(json_wizards_h "${CMAKE_CURRENT_BINARY_DIR}/jsonwizards_tr.h")
  add_custom_command(OUTPUT "${json_wizards_h}"
    COMMAND "${PYTHON_EXECUTABLE}"
      "${CMAKE_CURRENT_SOURCE_DIR}/extract-jsonwizards.py"
      "${PROJECT_SOURCE_DIR}/share/qtcreator/templates/wizards" "${json_wizards_h}"
    COMMENT Generate translation data from JSON wizards
    VERBATIM)

  set(custom_wizards_h "${CMAKE_CURRENT_BINARY_DIR}/customwizards_tr.h")
  add_custom_command(OUTPUT "${custom_wizards_h}"
    COMMAND "${PYTHON_EXECUTABLE}"
      "${CMAKE_CURRENT_SOURCE_DIR}/extract-customwizards.py"
      "${PROJECT_SOURCE_DIR}/share/qtcreator/templates/wizards" "${custom_wizards_h}"
    COMMENT Generate translation data from XML wizards
    VERBATIM)

  set(externaltools_h "${CMAKE_CURRENT_BINARY_DIR}/externaltools_tr.h")
  add_custom_command(OUTPUT "${externaltools_h}"
    COMMAND "${PYTHON_EXECUTABLE}"
      "${CMAKE_CURRENT_SOURCE_DIR}/extract-externaltools.py"
      "${PROJECT_SOURCE_DIR}/src/share/qtcreator/externaltools" "${externaltools_h}"
    COMMENT Generate translation data from external tools definitions
    VERBATIM)

  set(snippets_h "${CMAKE_CURRENT_BINARY_DIR}/snippets_tr.h")
  add_custom_command(OUTPUT "${snippets_h}"
    COMMAND "${PYTHON_EXECUTABLE}"
      "${CMAKE_CURRENT_SOURCE_DIR}/extract-snippets.py"
      "${PROJECT_SOURCE_DIR}/share/qtcreator/snippets" "${snippets_h}"
    COMMENT Generate translation data from snippets definitions
    VERBATIM)
endif()

add_translation_targets(qtcreator
  LANGUAGES ${languages}
  OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${IDE_DATA_PATH}/translations"
  INSTALL_DESTINATION "${IDE_DATA_PATH}/translations"
  TARGETS "${__QTC_LIBRARIES}" "${__QTC_PLUGINS}"
  SOURCES "${json_wizards_h}" "${custom_wizards_h}" "${externaltools_h}" "${snippets_h}")

=== src/libs/advanceddockingsystem/CMakeLists.txt ===
add_qtc_library(AdvancedDockingSystem
  DEPENDS Qt5::Widgets Qt5::Core Qt5::Gui Utils
  SOURCES
    ads_globals.cpp ads_globals.h
    dockareatabbar.cpp dockareatabbar.h
    dockareatitlebar.cpp dockareatitlebar.h
    dockareawidget.cpp dockareawidget.h
    dockcomponentsfactory.cpp dockcomponentsfactory.h
    dockcontainerwidget.cpp dockcontainerwidget.h
    dockfocuscontroller.cpp dockfocuscontroller.h
    dockingstatereader.cpp dockingstatereader.h
    dockmanager.cpp dockmanager.h
    dockoverlay.cpp dockoverlay.h
    docksplitter.cpp docksplitter.h
    dockwidget.cpp dockwidget.h
    dockwidgettab.cpp dockwidgettab.h
    elidinglabel.cpp elidinglabel.h
    floatingdockcontainer.cpp floatingdockcontainer.h
    floatingdragpreview.cpp floatingdragpreview.h
    iconprovider.cpp iconprovider.h
    workspacedialog.cpp workspacedialog.h
    workspacemodel.cpp workspacemodel.h
    workspaceview.cpp workspaceview.h
    workspacedialog.ui
)

extend_qtc_library(AdvancedDockingSystem
  INCLUDES linux
  SOURCES
    linux/floatingwidgettitlebar.cpp linux/floatingwidgettitlebar.h
)

=== src/libs/clangsupport/CMakeLists.txt ===
set(CLANG_VERSION ${LLVM_VERSION_MAJOR}.${LLVM_VERSION_MINOR}.${LLVM_VERSION_PATCH})

add_qtc_library(ClangSupport
  DEPENDS Threads::Threads
  PUBLIC_DEPENDS Utils Sqlite Qt5::Core Qt5::Network
  PUBLIC_DEFINES
    CLANG_VERSION="${CLANG_VERSION}"
    CLANG_INCLUDE_DIR="${LLVM_LIBRARY_DIR}/clang/${CLANG_VERSION}/include"
    CLANG_BINDIR="${LLVM_TOOLS_BINARY_DIR}"
  DEFINES CLANGSUPPORT_BUILD_LIB
  PUBLIC_INCLUDES
    "${CMAKE_CURRENT_LIST_DIR}"
  SOURCES
    alivemessage.cpp alivemessage.h
    annotationsmessage.cpp annotationsmessage.h
    baseserverproxy.cpp baseserverproxy.h
    cancelmessage.cpp cancelmessage.h
    clangcodemodelclientinterface.cpp clangcodemodelclientinterface.h
    clangcodemodelclientmessages.h
    clangcodemodelclientproxy.cpp clangcodemodelclientproxy.h
    clangcodemodelconnectionclient.cpp clangcodemodelconnectionclient.h
    clangcodemodelserverinterface.cpp clangcodemodelserverinterface.h
    clangcodemodelservermessages.h
    clangcodemodelserverproxy.cpp clangcodemodelserverproxy.h
    clangpathwatcher.h
    clangpathwatcherinterface.h
    clangpathwatchernotifier.h
    clangrefactoringclientmessages.h
    clangrefactoringmessages.h
    clangrefactoringservermessages.h
    clangsupport_global.h
    clangsupportdebugutils.cpp clangsupportdebugutils.h
    clangsupportexceptions.h
    codecompletion.cpp codecompletion.h
    codecompletionchunk.cpp codecompletionchunk.h
    commandlinebuilder.h
    compilermacro.h
    completionsmessage.cpp completionsmessage.h
    connectionclient.cpp connectionclient.h
    connectionserver.cpp connectionserver.h
    diagnosticcontainer.cpp diagnosticcontainer.h
    directoryandfilepathid.h
    directorypathid.h
    documentschangedmessage.cpp documentschangedmessage.h
    documentsclosedmessage.cpp documentsclosedmessage.h
    documentsopenedmessage.cpp documentsopenedmessage.h
    documentvisibilitychangedmessage.cpp documentvisibilitychangedmessage.h
    dynamicastmatcherdiagnosticcontainer.cpp dynamicastmatcherdiagnosticcontainer.h
    dynamicastmatcherdiagnosticcontextcontainer.cpp dynamicastmatcherdiagnosticcontextcontainer.h
    dynamicastmatcherdiagnosticmessagecontainer.cpp dynamicastmatcherdiagnosticmessagecontainer.h
    dynamicmatcherdiagnostics.h
    echomessage.cpp echomessage.h
    endmessage.cpp endmessage.h
    environment.h
    executeinloop.h
    filecontainer.cpp filecontainer.h
    filecontainerv2.cpp filecontainerv2.h
    filepath.cpp filepath.h
    filepathcache.h
    filepathcaching.cpp filepathcaching.h
    filepathcachingfwd.h
    filepathcachinginterface.h
    filepathexceptions.h
    filepathid.cpp filepathid.h
    filepathstorage.h
    filepathstoragesources.h
    filepathstoragesqlitestatementfactory.h
    filepathview.h
    filestatus.h
    filestatuscache.cpp filestatuscache.h
    filesystem.cpp filesystem.h
    filesysteminterface.h
    fixitcontainer.cpp fixitcontainer.h
    followsymbolmessage.cpp followsymbolmessage.h
    generatedfiles.cpp generatedfiles.h
    generatedfilesinterface.h
    idpaths.h
    includesearchpath.h
    ipcclientinterface.h
    ipcclientprovider.h
    ipcinterface.h
    ipcserverinterface.h
    lineprefixer.cpp lineprefixer.h
    messageenvelop.cpp messageenvelop.h
    modifiedtimechecker.h
    modifiedtimecheckerinterface.h
    nativefilepath.h
    pchmanagerclientinterface.cpp pchmanagerclientinterface.h
    pchmanagerclientproxy.cpp pchmanagerclientproxy.h
    pchmanagerserverinterface.cpp pchmanagerserverinterface.h
    pchmanagerserverproxy.cpp pchmanagerserverproxy.h
    pchpaths.h
    precompiledheadersupdatedmessage.cpp precompiledheadersupdatedmessage.h
    processcreator.cpp processcreator.h
    processexception.cpp processexception.h
    processhandle.h
    processstartedevent.cpp processstartedevent.h
    progresscounter.h
    progressmessage.h
    projectmanagementserverinterface.h
    projectpartartefact.cpp projectpartartefact.h
    projectpartcontainer.cpp projectpartcontainer.h
    projectpartid.h
    projectpartpch.cpp projectpartpch.h
    projectpartsstorage.h
    projectpartsstorageinterface.h
    readmessageblock.cpp readmessageblock.h
    refactoringclientinterface.cpp refactoringclientinterface.h
    refactoringclientproxy.cpp refactoringclientproxy.h
    refactoringdatabaseinitializer.h
    refactoringserverinterface.cpp refactoringserverinterface.h
    refactoringserverproxy.cpp refactoringserverproxy.h
    referencesmessage.cpp referencesmessage.h
    removegeneratedfilesmessage.cpp removegeneratedfilesmessage.h
    removeprojectpartsmessage.h
    requestannotationsmessage.cpp requestannotationsmessage.h
    requestcompletionsmessage.cpp requestcompletionsmessage.h
    requestfollowsymbolmessage.cpp requestfollowsymbolmessage.h
    requestreferencesmessage.cpp requestreferencesmessage.h
    requestsourcerangesanddiagnosticsforquerymessage.cpp requestsourcerangesanddiagnosticsforquerymessage.h
    requestsourcerangesforquerymessage.cpp requestsourcerangesforquerymessage.h
    requesttooltipmessage.cpp requesttooltipmessage.h
    sourceentry.h
    sourcelocationcontainer.cpp sourcelocationcontainer.h
    sourcelocationcontainerv2.cpp sourcelocationcontainerv2.h
    sourcelocationscontainer.cpp sourcelocationscontainer.h
    sourcerangecontainer.cpp sourcerangecontainer.h
    sourcerangecontainerv2.cpp sourcerangecontainerv2.h
    sourcerangesanddiagnosticsforquerymessage.cpp sourcerangesanddiagnosticsforquerymessage.h
    sourcerangescontainer.cpp sourcerangescontainer.h
    sourcerangesforquerymessage.cpp sourcerangesforquerymessage.h
    sourcerangewithtextcontainer.cpp sourcerangewithtextcontainer.h
    stringcache.h
    stringcachealgorithms.h
    stringcachefwd.h
    tokeninfocontainer.cpp tokeninfocontainer.h
    tooltipinfo.cpp tooltipinfo.h
    tooltipmessage.cpp tooltipmessage.h
    unsavedfilesremovedmessage.cpp unsavedfilesremovedmessage.h
    unsavedfilesupdatedmessage.cpp unsavedfilesupdatedmessage.h
    updategeneratedfilesmessage.cpp updategeneratedfilesmessage.h
    updateprojectpartsmessage.cpp updateprojectpartsmessage.h
    writemessageblock.cpp writemessageblock.h
)

if (NOT TARGET libclang)
  return()
endif()

=== src/libs/qtcreatorcdbext/CMakeLists.txt ===
if (NOT WIN32 OR NOT MSVC)
  return()
endif()

find_library(DbgEngLib dbgeng)

set(ArchSuffix 32)
if (CMAKE_SIZEOF_VOID_P EQUAL 8)
  set(ArchSuffix 64)
endif()

# statically link MSVC runtime
# see https://gitlab.kitware.com/cmake/community/-/wikis/FAQ#how-can-i-build-my-msvc-application-with-a-static-runtime
# TODO change to MSVC_RUNTIME_LIBRARY when CMake 3.15 is required
# set_property(TARGET qtcreatorcdbext PROPERTY MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
foreach(flag_var
    CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
    CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
  if(${flag_var} MATCHES "/MD")
    string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
  endif()
endforeach()

add_qtc_library(qtcreatorcdbext
  COMPONENT qtcreatorcdbext
  UNVERSIONED
  DEPENDS ${DbgEngLib}
  DESTINATION lib/qtcreatorcdbext${ArchSuffix}/
  SOURCES
    common.cpp common.h
    containers.cpp containers.h
    eventcallback.cpp eventcallback.h
    extensioncontext.cpp extensioncontext.h
    gdbmihelpers.cpp gdbmihelpers.h
    iinterfacepointer.h
    knowntype.h
    outputcallback.cpp outputcallback.h
    qtcreatorcdbext.def
    qtcreatorcdbextension.cpp
    stringutils.cpp stringutils.h
    symbolgroup.cpp symbolgroup.h
    symbolgroupnode.cpp symbolgroupnode.h
    symbolgroupvalue.cpp symbolgroupvalue.h
)

qtc_library_enabled(_library_enabled qtcreatorcdbext)
if (_library_enabled)
  find_package(PythonLibs 3.8)
  if (NOT ${PYTHONLIBS_FOUND})
    message(WARNING "PythonLibs (at least version 3.8) not found. qtcreatorcdbext will be built without Python support.")
    return()
  endif()

  set(PythonRegex "^(.*)/(.*)/(python([0-9]+))${CMAKE_IMPORT_LIBRARY_SUFFIX}$")
  if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(PythonRegex "^(.*)/(.*)/(python([0-9]+)_d)${CMAKE_IMPORT_LIBRARY_SUFFIX}$")
  endif()

  foreach(lib IN LISTS PYTHON_LIBRARIES)
    if (lib MATCHES ${PythonRegex})
      if (CMAKE_BUILD_TYPE STREQUAL "Debug")
        set(PythonZipFileName "python${CMAKE_MATCH_4}_d.zip")
      else()
        set(PythonZipFileName "python${CMAKE_MATCH_4}.zip")
      endif()

      set(PythonDll "${CMAKE_MATCH_1}/${CMAKE_MATCH_3}${CMAKE_SHARED_LIBRARY_SUFFIX}")
      set(PythonExe "${CMAKE_MATCH_1}/python${CMAKE_EXECUTABLE_SUFFIX}")
      set(PythonZip "${CMAKE_MATCH_1}/${PythonZipFileName}")

      break()
    endif()
  endforeach()

  if (NOT PythonDll)
    if (CMAKE_BUILD_TYPE STREQUAL "Debug")
      message(WARNING "The Debug build of Qt Creator requires Debug Python libraries. Please check your Python installation")
    endif()
    message(WARNING "PythonDll not found. qtcreatorcdbext will be built without Python support.")
    return()
  endif()

  extend_qtc_library(qtcreatorcdbext
    DEPENDS "${PYTHON_LIBRARIES}"
    INCLUDES "${PYTHON_INCLUDE_DIR}"
    DEFINES WITH_PYTHON=1
    SOURCES
      pycdbextmodule.cpp pycdbextmodule.h
      pyfield.cpp pyfield.h
      pystdoutredirect.cpp pystdoutredirect.h
      pytype.cpp pytype.h
      pyvalue.cpp pyvalue.h
  )

  if (NOT EXISTS "${PythonZip}" AND
      NOT EXISTS "${CMAKE_CURRENT_BINARY_DIR}/${PythonZipFileName}")
    include(CreatePythonXY)
    create_python_xy("${PythonExe}" "${CMAKE_CURRENT_BINARY_DIR}/${PythonZipFileName}")
  endif()

  if (NOT EXISTS "${PythonZip}" AND
      EXISTS "${CMAKE_CURRENT_BINARY_DIR}/${PythonZipFileName}")
    set(PythonZip "${CMAKE_CURRENT_BINARY_DIR}/${PythonZipFileName}")
  endif()

  list(APPEND deployPythonFiles "${PythonDll}")
  list(APPEND deployPythonFiles "${PythonZip}")

  install(FILES ${deployPythonFiles}
          DESTINATION lib/qtcreatorcdbext${ArchSuffix}/
          COMPONENT qtcreatorcdbext)

  add_custom_target(copy_python_dll ALL VERBATIM)
  add_custom_command(TARGET copy_python_dll POST_BUILD
    COMMAND "${CMAKE_COMMAND}" -E copy ${deployPythonFiles} "${PROJECT_BINARY_DIR}/lib/qtcreatorcdbext${ArchSuffix}/"
    VERBATIM
  )
endif()

=== src/libs/sqlite/CMakeLists.txt ===
add_qtc_library(Sqlite
  PUBLIC_DEFINES
      BUILD_SQLITE_LIBRARY
      SQLITE_THREADSAFE=2 SQLITE_ENABLE_FTS5 SQLITE_ENABLE_UNLOCK_NOTIFY
      SQLITE_ENABLE_JSON1 SQLITE_DEFAULT_FOREIGN_KEYS=1 SQLITE_TEMP_STORE=2
      SQLITE_DEFAULT_WAL_SYNCHRONOUS=1 SQLITE_MAX_WORKER_THREADS SQLITE_DEFAULT_MEMSTATUS=0
      SQLITE_OMIT_DEPRECATED SQLITE_OMIT_DECLTYPE
      SQLITE_MAX_EXPR_DEPTH=0 SQLITE_OMIT_SHARED_CACHE SQLITE_USE_ALLOCA
      SQLITE_ENABLE_MEMORY_MANAGEMENT SQLITE_ENABLE_NULL_TRIM SQLITE_OMIT_EXPLAIN
      SQLITE_OMIT_LOAD_EXTENSION SQLITE_OMIT_UTF16 SQLITE_DQS=0
      SQLITE_ENABLE_STAT4 HAVE_ISNAN HAVE_FDATASYNC HAVE_MALLOC_USABLE_SIZE
      SQLITE_DEFAULT_MMAP_SIZE=268435456 SQLITE_CORE SQLITE_ENABLE_SESSION SQLITE_ENABLE_PREUPDATE_HOOK
      SQLITE_LIKE_DOESNT_MATCH_BLOBS
  DEPENDS Qt5::Core Threads::Threads ${CMAKE_DL_LIBS}
  PUBLIC_INCLUDES
    "${CMAKE_CURRENT_LIST_DIR}"
    ../3rdparty/sqlite
  SOURCES
    ../3rdparty/sqlite/sqlite3.c
    ../3rdparty/sqlite/sqlite3.h
    ../3rdparty/sqlite/carray.c
    constraints.h
    createtablesqlstatementbuilder.cpp createtablesqlstatementbuilder.h
    lastchangedrowid.h
    sqlitebasestatement.cpp sqlitebasestatement.h
    sqlitecolumn.h
    sqlitedatabase.cpp sqlitedatabase.h
    sqlitedatabasebackend.cpp sqlitedatabasebackend.h
    sqlitedatabaseinterface.h
    sqliteexception.cpp sqliteexception.h
    sqliteglobal.cpp sqliteglobal.h
    sqliteindex.h
    sqlitereadstatement.cpp sqlitereadstatement.h
    sqlitereadwritestatement.cpp sqlitereadwritestatement.h
    sqlitesessionchangeset.cpp sqlitesessionchangeset.h
    sqlitesessions.cpp sqlitesessions.h
    sqlitetable.h
    sqlitetransaction.h
    sqlitetransaction.h
    sqlitevalue.h
    sqlitewritestatement.cpp sqlitewritestatement.h
    sqlstatementbuilder.cpp sqlstatementbuilder.h
    sqlstatementbuilderexception.h
    tableconstraints.h
    utf8string.cpp utf8string.h
    utf8stringvector.cpp utf8stringvector.h
    sqliteblob.h
    sqlitetimestamp.h
)

=== src/libs/utils/CMakeLists.txt ===
add_qtc_library(Utils
  DEPENDS Qt5::Qml Qt5::Xml
  PUBLIC_DEPENDS
    Qt5::Concurrent Qt5::Core Qt5::Network Qt5::Gui Qt5::Widgets
    Qt6Core5Compat
  DEFINES
    "QTC_REL_TOOLS_PATH=\"${RELATIVE_LIBEXEC_PATH}\""
  SOURCES
    ../3rdparty/optional/optional.hpp
    ../3rdparty/variant/variant.hpp
    ../3rdparty/span/span.hpp
    QtConcurrentTools
    algorithm.h
    ansiescapecodehandler.cpp ansiescapecodehandler.h
    appmainwindow.cpp appmainwindow.h
    archive.cpp archive.h
    aspects.cpp aspects.h
    basetreeview.cpp basetreeview.h
    benchmarker.cpp benchmarker.h
    buildablehelperlibrary.cpp buildablehelperlibrary.h
    camelcasecursor.cpp camelcasecursor.h
    categorysortfiltermodel.cpp categorysortfiltermodel.h
    changeset.cpp changeset.h
    checkablemessagebox.cpp checkablemessagebox.h
    classnamevalidatinglineedit.cpp classnamevalidatinglineedit.h
    codegeneration.cpp codegeneration.h
    completinglineedit.cpp completinglineedit.h
    completingtextedit.cpp completingtextedit.h
    consoleprocess.cpp consoleprocess.h
    cpplanguage_details.h
    crumblepath.cpp crumblepath.h
    declarationmacros.h
    delegates.cpp delegates.h
    detailsbutton.cpp detailsbutton.h
    detailswidget.cpp detailswidget.h
    differ.cpp differ.h
    displayname.cpp displayname.h
    dropsupport.cpp dropsupport.h
    elfreader.cpp elfreader.h
    elidinglabel.cpp elidinglabel.h
    environment.cpp environment.h
    environmentdialog.cpp environmentdialog.h
    environmentfwd.h
    environmentmodel.cpp environmentmodel.h
    execmenu.cpp execmenu.h
    executeondestruction.h
    fadingindicator.cpp fadingindicator.h
    faketooltip.cpp faketooltip.h
    fancylineedit.cpp fancylineedit.h
    fancymainwindow.cpp fancymainwindow.h
    filecrumblabel.cpp filecrumblabel.h
    fileinprojectfinder.cpp fileinprojectfinder.h
    filenamevalidatinglineedit.cpp filenamevalidatinglineedit.h
    filesearch.cpp filesearch.h
    filesystemwatcher.cpp filesystemwatcher.h
    fileutils.cpp fileutils.h
    filewizardpage.cpp filewizardpage.h
    fixedsizeclicklabel.cpp fixedsizeclicklabel.h
    flowlayout.cpp flowlayout.h
    functiontraits.h
    fuzzymatcher.cpp fuzzymatcher.h
    genericconstants.h
    globalfilechangeblocker.cpp globalfilechangeblocker.h
    guard.cpp guard.h
    headerviewstretcher.cpp headerviewstretcher.h
    highlightingitemdelegate.cpp highlightingitemdelegate.h
    historycompleter.cpp historycompleter.h
    hostosinfo.cpp hostosinfo.h
    htmldocextractor.cpp htmldocextractor.h
    icon.cpp icon.h
    id.cpp id.h
    infobar.cpp infobar.h
    infolabel.cpp infolabel.h
    itemviews.cpp itemviews.h
    json.cpp json.h
    jsontreeitem.cpp jsontreeitem.h
    layoutbuilder.cpp layoutbuilder.h
    linecolumn.h
    link.h
    listmodel.h
    listutils.h
    macroexpander.cpp macroexpander.h
    mapreduce.h
    mimetypes/mimedatabase.cpp mimetypes/mimedatabase.h mimetypes/mimedatabase_p.h
    mimetypes/mimeglobpattern.cpp mimetypes/mimeglobpattern_p.h
    mimetypes/mimemagicrule.cpp mimetypes/mimemagicrule_p.h
    mimetypes/mimemagicrulematcher.cpp mimetypes/mimemagicrulematcher_p.h
    mimetypes/mimeprovider.cpp mimetypes/mimeprovider_p.h
    mimetypes/mimetype.cpp mimetypes/mimetype.h mimetypes/mimetype_p.h
    mimetypes/mimetypeparser.cpp mimetypes/mimetypeparser_p.h
    namevaluedictionary.cpp namevaluedictionary.h
    namevaluedictionary.cpp namevaluedictionary.h
    namevalueitem.cpp namevalueitem.h
    namevalueitem.cpp namevalueitem.h
    namevaluemodel.cpp namevaluemodel.h
    namevaluemodel.cpp namevaluemodel.h
    namevaluesdialog.cpp namevaluesdialog.h
    namevaluesdialog.cpp namevaluesdialog.h
    namevaluevalidator.cpp namevaluevalidator.h
    namevaluevalidator.cpp namevaluevalidator.h
    navigationtreeview.cpp navigationtreeview.h
    networkaccessmanager.cpp networkaccessmanager.h
    optional.h
    osspecificaspects.h
    outputformat.h
    outputformatter.cpp outputformatter.h
    overlaywidget.cpp overlaywidget.h
    overridecursor.cpp overridecursor.h
    parameteraction.cpp parameteraction.h
    pathchooser.cpp pathchooser.h
    pathlisteditor.cpp pathlisteditor.h
    persistentsettings.cpp persistentsettings.h
    pointeralgorithm.h
    port.cpp port.h
    porting.h
    portlist.cpp portlist.h
    predicates.h
    processhandle.cpp processhandle.h
    progressindicator.cpp progressindicator.h
    projectintropage.cpp projectintropage.h projectintropage.ui
    proxyaction.cpp proxyaction.h
    proxycredentialsdialog.cpp proxycredentialsdialog.h proxycredentialsdialog.ui
    qrcparser.cpp qrcparser.h
    qtcassert.cpp qtcassert.h
    qtcolorbutton.cpp qtcolorbutton.h
    qtcprocess.cpp qtcprocess.h
    reloadpromptutils.cpp reloadpromptutils.h
    removefiledialog.cpp removefiledialog.h removefiledialog.ui
    runextensions.cpp runextensions.h
    savedaction.cpp savedaction.h
    savefile.cpp savefile.h
    scopedswap.h
    set_algorithm.h
    settingsaccessor.cpp settingsaccessor.h
    settingsselector.cpp settingsselector.h
    settingsutils.h
    shellcommand.cpp shellcommand.h
    shellcommandpage.cpp shellcommandpage.h
    sizedarray.h
    smallstring.h
    smallstringfwd.h
    smallstringio.h
    smallstringiterator.h
    smallstringlayout.h
    smallstringliteral.h
    smallstringmemory.h
    smallstringvector.h
    smallstringview.h
    span.h
    statuslabel.cpp statuslabel.h
    stringutils.cpp stringutils.h
    styledbar.cpp styledbar.h
    stylehelper.cpp stylehelper.h
    synchronousprocess.cpp synchronousprocess.h
    templateengine.cpp templateengine.h
    temporarydirectory.cpp temporarydirectory.h
    temporaryfile.cpp temporaryfile.h
    textfieldcheckbox.cpp textfieldcheckbox.h
    textfieldcombobox.cpp textfieldcombobox.h
    textfileformat.cpp textfileformat.h
    textutils.cpp textutils.h
    theme/theme.cpp theme/theme.h theme/theme_p.h
    tooltip/effects.h
    tooltip/tips.cpp tooltip/tips.h
    tooltip/tooltip.cpp tooltip/tooltip.h
    touchbar/touchbar.h
    treemodel.cpp treemodel.h
    treeviewcombobox.cpp treeviewcombobox.h
    uncommentselection.cpp uncommentselection.h
    unixutils.cpp unixutils.h
    url.cpp url.h
    utils.qrc
    utils_global.h
    utilsicons.cpp utilsicons.h
    variablechooser.cpp variablechooser.h
    variant.h
    winutils.cpp winutils.h
    wizard.cpp wizard.h
    wizardpage.cpp wizardpage.h
)

extend_qtc_library(Utils CONDITION WIN32
  SOURCES
    touchbar/touchbar.cpp
  DEPENDS
    user32 iphlpapi ws2_32 shell32
  DEFINES
    _UNICODE UNICODE
  PUBLIC_DEFINES
    _CRT_SECURE_NO_WARNINGS _SCL_SECURE_NO_WARNINGS
)

extend_qtc_library(Utils CONDITION APPLE
  SOURCES
    fileutils_mac.mm fileutils_mac.h
    processhandle_mac.mm
    theme/theme_mac.mm theme/theme_mac.h
    touchbar/touchbar_appdelegate_mac.mm touchbar/touchbar_appdelegate_mac_p.h
    touchbar/touchbar_mac.mm touchbar/touchbar_mac_p.h
  DEPENDS
    ${FWFoundation} ${FWAppKit}
)

extend_qtc_library(Utils CONDITION UNIX AND NOT APPLE
  SOURCES
    touchbar/touchbar.cpp
)

if (WIN32)
  add_qtc_executable(qtcreator_process_stub
    SOURCES process_stub_win.c
    DEPENDS shell32
    DEFINES _UNICODE UNICODE _CRT_SECURE_NO_WARNINGS
  )

  add_qtc_executable(qtcreator_ctrlc_stub
    DEPENDS user32 shell32
    DEFINES _UNICODE UNICODE _CRT_SECURE_NO_WARNINGS
    SOURCES
      process_ctrlc_stub.cpp
  )
else()
  add_qtc_executable(qtcreator_process_stub SOURCES process_stub_unix.c)
endif()

=== src/plugins/bookmarks/CMakeLists.txt ===
add_qtc_plugin(Bookmarks
  PLUGIN_DEPENDS Core ProjectExplorer TextEditor
  SOURCES
    bookmark.cpp bookmark.h
    bookmarkfilter.cpp bookmarkfilter.h
    bookmarkmanager.cpp bookmarkmanager.h
    bookmarks_global.h
    bookmarksplugin.cpp bookmarksplugin.h
)

=== src/plugins/clangformat/CMakeLists.txt ===
add_qtc_plugin(ClangFormat
  CONDITION TARGET libclang AND LLVM_PACKAGE_VERSION VERSION_GREATER_EQUAL 10.0.0 AND QTC_CLANG_BUILDMODE_MATCH
  DEPENDS Utils Qt5::Widgets ${CLANG_FORMAT_LIB}
  INCLUDES "${CLANG_INCLUDE_DIRS}"
  PLUGIN_DEPENDS Core TextEditor CppEditor CppTools ProjectExplorer
  SOURCES
    clangformatbaseindenter.cpp clangformatbaseindenter.h
    clangformatchecks.ui
    clangformatconfigwidget.cpp clangformatconfigwidget.h clangformatconfigwidget.ui
    clangformatconstants.h
    clangformatindenter.cpp clangformatindenter.h
    clangformatplugin.cpp clangformatplugin.h
    clangformatsettings.cpp clangformatsettings.h
    clangformatutils.cpp clangformatutils.h
)

extend_qtc_plugin(ClangFormat
  CONDITION UNIX AND NOT APPLE
  PROPERTIES LINK_FLAGS "-Wl,--exclude-libs,ALL"
)

=== src/plugins/clangrefactoring/CMakeLists.txt ===
add_qtc_plugin(ClangRefactoring
  BUILD_DEFAULT OFF
  CONDITION TARGET libclang AND QTC_CLANG_BUILDMODE_MATCH
  DEPENDS ClangSupport CPlusPlus
  PLUGIN_DEPENDS Core CppTools TextEditor ClangPchManager
  SOURCES ${TEST_SOURCES}
    baseclangquerytexteditorwidget.cpp baseclangquerytexteditorwidget.h
    clangqueryexamplehighlighter.cpp clangqueryexamplehighlighter.h
    clangqueryexamplehighlightmarker.h
    clangqueryexampletexteditorwidget.cpp clangqueryexampletexteditorwidget.h
    clangqueryhighlighter.cpp clangqueryhighlighter.h
    clangqueryhighlightmarker.h
    clangqueryhoverhandler.cpp clangqueryhoverhandler.h
    clangqueryprojectsfindfilter.cpp clangqueryprojectsfindfilter.h clangqueryprojectsfindfilter.ui
    clangqueryprojectsfindfilterwidget.cpp clangqueryprojectsfindfilterwidget.h
    clangquerytexteditorwidget.cpp clangquerytexteditorwidget.h
    clangrefactoringplugin.cpp clangrefactoringplugin.h
    editormanagerinterface.h
    locatorfilter.cpp locatorfilter.h
    projectpartproviderinterface.h
    projectpartutilities.cpp projectpartutilities.h
    qtcreatorclangqueryfindfilter.cpp qtcreatorclangqueryfindfilter.h
    qtcreatoreditormanager.cpp qtcreatoreditormanager.h
    qtcreatorrefactoringprojectupdater.cpp qtcreatorrefactoringprojectupdater.h
    qtcreatorsearch.cpp qtcreatorsearch.h
    qtcreatorsearchhandle.cpp qtcreatorsearchhandle.h
    qtcreatorsymbolsfindfilter.cpp qtcreatorsymbolsfindfilter.h
    querysqlitestatementfactory.h
    refactoringclient.cpp refactoringclient.h
    refactoringconnectionclient.cpp refactoringconnectionclient.h
    refactoringengine.cpp refactoringengine.h
    refactoringprojectupdater.cpp refactoringprojectupdater.h
    searchhandle.cpp searchhandle.h
    searchinterface.h
    sourcelocations.h
    symbol.h
    symbolquery.h
    symbolqueryinterface.h
    clangsymbolsfindfilter.cpp clangsymbolsfindfilter.h
    symbolsfindfilterconfigwidget.cpp symbolsfindfilterconfigwidget.h
)

=== debian/changelog ===
qtcreator (4.14.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update the patches:
    - upstream_cmake-build-Fix-fallback-LLVM-Clang-paths.patch: drop,
      backported from upstream
    - upstream_cmake-build-Use-GNUInstallDirs-for-installation-path.patch:
      drop, backported from upstream
    - upstream_cmake-build-Don-t-install-highlighting-files-when-us.patch:
      drop, backported from upstream
  * Use execute_after_dh_auto_install, and execute_after_dh_install to avoid
    invoking dh_auto_install, and dh_install manually.
  * Limit the dh bits for installing the upstream changelogs to -indep packages
    only.

 -- Pino Toscano <pino@debian.org>  Fri, 26 Feb 2021 10:37:39 +0100

=== debian/control ===
Source: qtcreator
Section: devel
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Adam Majer <adamm@zombino.com>,
           Jeremy Lainé <jeremy.laine@m4x.org>,
           Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>,
           Simon Quigley <tsimonq2@debian.org>
Build-Depends: clang (>= 1:10~),
               cmake (>= 3.10~),
               debhelper-compat (= 13),
               libclang-dev (>= 1:10~),
               libdw-dev,
               libicu-dev,
               libjs-jquery,
               libkf5syntaxhighlighting-dev,
               liblitehtml-dev,
               libqt5opengl5-dev (>= 5.14.0~),
               libqt5serialport5-dev (>= 5.14.0~),
               libqt5sql5-sqlite (>= 5.14.0~),
               libqt5svg5-dev (>= 5.14.0~),
               libqt5x11extras5-dev (>= 5.14.0~),
               libyaml-cpp-dev (>= 0.5~),
               libzstd-dev,
               llvm-dev (>= 1:10~),
               pkg-config,
               qml-module-qtquick-controls (>= 5.14.0~),
               qml-module-qtquick2 (>= 5.14.0~),
               qtbase5-dev (>= 5.14.0~),
               qtbase5-private-dev (>= 5.14.0~),
               qtdeclarative5-dev (>= 5.14.0~),
               qtdeclarative5-private-dev (>= 5.14.0~),
               qtscript5-dev (>= 5.14.0~),
               qttools5-dev (>= 5.14.0~),
               qttools5-dev-tools (>= 5.14.0~),
               qttools5-private-dev (>= 5.14.0~),
               qtxmlpatterns5-dev-tools (>= 5.14.0~),
               zlib1g-dev
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://doc.qt.io/qt-5/topics-app-development.html
Vcs-Git: https://salsa.debian.org/qt-kde-team/qt/qtcreator.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/qt/qtcreator

Package: qtcreator
Architecture: any
Depends: libqt5sql5-sqlite,
         qml-module-qtqml-models2,
         qml-module-qtquick-controls (>= 5.5.0~),
         qml-module-qtquick2 (>= 5.5.0~),
         qtchooser,
         qtcreator-data (= ${source:Version}),
         ${misc:Depends},
         ${qtcreator:clang},
         ${shlibs:Depends}
Recommends: clang-tidy,
            gdb,
            make,
            qmlscene,
            qt5-doc,
            qt5-qmltooling-plugins,
            qtbase5-dev-tools,
            qtcreator-doc,
            qtdeclarative5-dev-tools,
            qttools5-dev-tools,
            qttranslations5-l10n,
            qtxmlpatterns5-dev-tools,
            xterm | x-terminal-emulator
Suggests: clazy (>= 1.5), cmake, g++, git, meson, subversion, valgrind
Breaks: qtcreator-data (<< 4.5.2-2~)
Replaces: qtcreator-data (<< 4.5.2-2~)
Description: integrated development environment (IDE) for Qt
 Qt Creator is a cross-platform integrated development environment (IDE)
 designed to make development with the Qt application framework faster
 and easier.
 .
 It includes:
  * An advanced C++ code editor
  * Integrated GUI layout and forms designer
  * Project and build management tools
  * Integrated, context-sensitive help system
  * Visual debugger
  * Rapid code navigation tools
  * Supports multiple platforms
  * Qt Quick Designer

Package: qtcreator-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: application data for Qt Creator IDE
 This package contains architecture-independent data for Qt Creator IDE.

Package: qtcreator-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: qt5-doc
Description: documentation for Qt Creator IDE
 Qt Creator is a cross-platform integrated development environment (IDE)
 designed to make development with the Qt application framework faster
 and easier.
 .
 This package contains documentation for Qt Creator IDE.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

export QT_SELECT := qt5

# Upstream changelog
upstream_changes = $(wildcard dist/changes-*)

# Do build the HelloWorld plugin, as it is not needed
export QTC_BUILD_PLUGIN_HELLOWORLD=FALSE
# Do not build the ClangFormat plugin, as it requires clang-format with
# a patch not accepted yet (and available only in the QtC fork):
# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=939825#49
# https://bugreports.qt.io/browse/QTCREATORBUG-22923
# https://reviews.llvm.org/D53072
export QTC_BUILD_PLUGIN_CLANGFORMAT=FALSE

# The clang-N used for the build by the unversioned clang
current_clang_pkg = $(shell dpkg -S "$(shell realpath $(shell env PATH=$$(echo "$$PATH" | sed -r -e 's|/usr/lib/ccache/?:||') which clang))" | cut -d: -f1)
# The upstream version of a package passed as parameter
upstream_version_of_pkg = $(shell dpkg-query -f '$${Version}' -W $(1) | sed -e 's/-[^-]*$$//')

%:
	dh $@ --builddirectory=builddir

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
		-DBUILD_DEVELOPER_DOCS=ON \
		-DBUILD_QBS=OFF \
		-DWITH_DOCS=$(if $(filter qtcreator-doc, $(shell dh_listpackages)),ON,OFF)

execute_after_dh_auto_build-indep:
	dh_auto_build -- docs

execute_after_dh_auto_install:
ifneq (,$(filter qtcreator-doc, $(shell dh_listpackages)))
	DESTDIR=$(CURDIR)/debian/tmp cmake --install $(CURDIR)/builddir --component qch_docs
	DESTDIR=$(CURDIR)/debian/tmp cmake --install $(CURDIR)/builddir --component html_docs
endif

	# Not needed
	rm debian/tmp/usr/bin/qtcreator.sh

	# Remove extra exec permissions
	find debian/tmp -name qmldir -type f -exec chmod -x {} \;

execute_after_dh_install:
	# Copied in qtcreator-doc already
	rm -rf debian/qtcreator-data/usr/share/qtcreator/doc/

override_dh_installdocs-indep:
	dh_installdocs -pqtcreator-data $(upstream_changes)
	dh_installdocs -i --remaining-packages

override_dh_makeshlibs:
	dh_makeshlibs -Xusr/lib/$(DEB_HOST_MULTIARCH)/qtcreator/

override_dh_shlibdeps:
	echo 'libQt5DesignerComponents 5 libqt5designercomponents5 (>= $(call upstream_version_of_pkg,libqt5designercomponents5)~)' > debian/shlibs.local
	dh_shlibdeps -l$(CURDIR)/debian/qtcreator/usr/lib/$(DEB_HOST_MULTIARCH)/qtcreator:\
	$(CURDIR)/debian/qtcreator/usr/lib/$(DEB_HOST_MULTIARCH)/qtcreator/plugins/QtProject
	rm debian/shlibs.local

override_dh_gencontrol-arch:
	dh_gencontrol -a -- -V'qtcreator:clang=$(current_clang_pkg) (>= $(call upstream_version_of_pkg,$(current_clang_pkg))~)'
